summaryrefslogtreecommitdiff
path: root/dev-lang
diff options
context:
space:
mode:
authorStefanCristian <steven.darklight@gmail.com>2016-04-06 01:46:44 +0300
committerStefanCristian <steven.darklight@gmail.com>2016-04-06 01:46:44 +0300
commit87fba126ecfc1c122ecd3338bdb899c6072d6e44 (patch)
tree7b2972414a2213ef225598e1fc786ef027d6928c /dev-lang
parente0b72f332f6d096daf958a6ad05f7a22eb37bb9c (diff)
[go*] added go-lang version 1.4 for docker stable 1.7.1
Diffstat (limited to 'dev-lang')
-rw-r--r--dev-lang/go-bootstrap/Manifest1
-rw-r--r--dev-lang/go-bootstrap/go-bootstrap-1.4.2.ebuild85
-rw-r--r--dev-lang/go-bootstrap/metadata.xml13
-rw-r--r--dev-lang/go/Manifest1
-rw-r--r--dev-lang/go/go-1.4.2.ebuild128
-rw-r--r--dev-lang/go/metadata.xml13
6 files changed, 241 insertions, 0 deletions
diff --git a/dev-lang/go-bootstrap/Manifest b/dev-lang/go-bootstrap/Manifest
new file mode 100644
index 00000000..dfae9c0a
--- /dev/null
+++ b/dev-lang/go-bootstrap/Manifest
@@ -0,0 +1 @@
+DIST go1.4.2.src.tar.gz 10921896 SHA256 299a6fd8f8adfdce15bc06bde926e7b252ae8e24dd5b16b7d8791ed79e7b5e9b SHA512 cda1a29d4418875dffaf3324004ddae8e1bbb573f7668e6e0c03d8b61284f4db7fca244c181f2859f8ccdd3db6391fb21e0d98a1a9fc15096c15883249d48a9c WHIRLPOOL d06c27f6ff3a6499a6c7cb3c5eccd53eb588896c4d837e1fe9855c22ee3caa5cc48fd68cbeceff105b7c47fafbbf0eb3dc28ee3af7196692c5bf18511c6760ef
diff --git a/dev-lang/go-bootstrap/go-bootstrap-1.4.2.ebuild b/dev-lang/go-bootstrap/go-bootstrap-1.4.2.ebuild
new file mode 100644
index 00000000..faba1caa
--- /dev/null
+++ b/dev-lang/go-bootstrap/go-bootstrap-1.4.2.ebuild
@@ -0,0 +1,85 @@
+# Copyright 1999-2015 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Id$
+
+EAPI=5
+
+export CTARGET=${CTARGET:-${CHOST}}
+
+inherit eutils toolchain-funcs
+
+SRC_URI="https://storage.googleapis.com/golang/go${PV}.src.tar.gz"
+# Upstream only supports go on amd64, arm and x86 architectures.
+KEYWORDS="-* ~amd64 ~arm ~x86 ~amd64-fbsd ~x86-fbsd ~x64-macos ~x86-macos"
+
+DESCRIPTION="Version of go compiler used for bootstrapping"
+HOMEPAGE="http://www.golang.org"
+
+LICENSE="BSD"
+SLOT="0"
+IUSE=""
+
+DEPEND=""
+RDEPEND=""
+
+# The go tools should not cause the multilib-strict check to fail.
+QA_MULTILIB_PATHS="usr/lib/go1.4/pkg/tool/.*/.*"
+
+# The go language uses *.a files which are _NOT_ libraries and should not be
+# stripped. The test data objects should also be left alone and unstripped.
+STRIP_MASK="/usr/lib/go1.4/pkg/*.a
+ /usr/lib/go1.4/src/debug/elf/testdata/*
+ /usr/lib/go1.4/src/debug/dwarf/testdata/*
+ /usr/lib/go1.4/src/runtime/race/*.syso"
+
+S="${WORKDIR}"/go
+
+src_prepare()
+{
+ sed -i -e 's/"-Werror",//g' src/cmd/dist/build.c
+}
+
+src_compile()
+{
+ export GOROOT_FINAL="${EPREFIX}"/usr/lib/go1.4
+ export GOROOT="$(pwd)"
+ export GOBIN="${GOROOT}/bin"
+ if [[ $CTARGET = armv5* ]]
+ then
+ export GOARM=5
+ fi
+ tc-export CC
+
+ cd src
+ ./make.bash || die "build failed"
+}
+
+src_test()
+{
+ cd src
+ PATH="${GOBIN}:${PATH}" \
+ ./run.bash --no-rebuild --banner || die "tests failed"
+}
+
+src_install()
+{
+ dodir /usr/lib/go1.4
+ exeinto /usr/lib/go1.4/bin
+ doexe bin/*
+ insinto /usr/lib/go1.4
+ doins -r lib pkg src
+ fperms -R +x /usr/lib/go1.4/pkg/tool
+}
+
+pkg_postinst()
+{
+ # If the go tool sees a package file timestamped older than a dependancy it
+ # will rebuild that file. So, in order to stop go from rebuilding lots of
+ # packages for every build we need to fix the timestamps. The compiler and
+ # linker are also checked - so we need to fix them too.
+ ebegin "fixing timestamps to avoid unnecessary rebuilds"
+ tref="usr/lib/go1.4/pkg/*/runtime.a"
+ find "${EROOT}"usr/lib/go1.4 -type f \
+ -exec touch -r "${EROOT}"${tref} {} \;
+ eend $?
+}
diff --git a/dev-lang/go-bootstrap/metadata.xml b/dev-lang/go-bootstrap/metadata.xml
new file mode 100644
index 00000000..afdfdb99
--- /dev/null
+++ b/dev-lang/go-bootstrap/metadata.xml
@@ -0,0 +1,13 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<!DOCTYPE pkgmetadata SYSTEM "http://www.gentoo.org/dtd/metadata.dtd">
+<pkgmetadata>
+ <maintainer>
+ <email>williamh@gentoo.org</email>
+ <name>William Hubbs</name>
+ </maintainer>
+ <longdescription lang="en">
+ This package is only necessary until gccgo supports go-1.4. It
+ will be removed as soon as stable gcc supports this.
+ It is here so that >=dev-lang/go 1.5 can use it to bootstrap.
+ </longdescription>
+</pkgmetadata>
diff --git a/dev-lang/go/Manifest b/dev-lang/go/Manifest
new file mode 100644
index 00000000..dfae9c0a
--- /dev/null
+++ b/dev-lang/go/Manifest
@@ -0,0 +1 @@
+DIST go1.4.2.src.tar.gz 10921896 SHA256 299a6fd8f8adfdce15bc06bde926e7b252ae8e24dd5b16b7d8791ed79e7b5e9b SHA512 cda1a29d4418875dffaf3324004ddae8e1bbb573f7668e6e0c03d8b61284f4db7fca244c181f2859f8ccdd3db6391fb21e0d98a1a9fc15096c15883249d48a9c WHIRLPOOL d06c27f6ff3a6499a6c7cb3c5eccd53eb588896c4d837e1fe9855c22ee3caa5cc48fd68cbeceff105b7c47fafbbf0eb3dc28ee3af7196692c5bf18511c6760ef
diff --git a/dev-lang/go/go-1.4.2.ebuild b/dev-lang/go/go-1.4.2.ebuild
new file mode 100644
index 00000000..8384e081
--- /dev/null
+++ b/dev-lang/go/go-1.4.2.ebuild
@@ -0,0 +1,128 @@
+# Copyright 1999-2015 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Id$
+
+EAPI=5
+
+export CTARGET=${CTARGET:-${CHOST}}
+
+inherit eutils toolchain-funcs
+
+if [[ ${PV} = 9999 ]]; then
+ EGIT_REPO_URI="git://github.com/golang/go.git"
+ inherit git-r3
+else
+ SRC_URI="https://storage.googleapis.com/golang/go${PV}.src.tar.gz"
+ # Upstream only supports go on amd64, arm and x86 architectures.
+ KEYWORDS="-* amd64 arm x86 ~amd64-fbsd ~x86-fbsd ~x64-macos ~x86-macos"
+fi
+
+DESCRIPTION="A concurrent garbage collected and typesafe programming language"
+HOMEPAGE="http://www.golang.org"
+
+LICENSE="BSD"
+SLOT="0"
+IUSE=""
+
+DEPEND=""
+RDEPEND=""
+
+# These test data objects have writable/executable stacks.
+QA_EXECSTACK="
+ usr/lib/go/src/debug/elf/testdata/go-relocation-test-gcc482-aarch64.obj
+ usr/lib/go/src/debug/elf/testdata/gcc-amd64-openbsd-debug-with-rela.obj"
+
+ REQUIRES_EXCLUDE="/usr/lib/go/src/debug/elf/testdata/*"
+
+# The tools in /usr/lib/go should not cause the multilib-strict check to fail.
+QA_MULTILIB_PATHS="usr/lib/go/pkg/tool/.*/.*"
+
+# The go language uses *.a files which are _NOT_ libraries and should not be
+# stripped.
+STRIP_MASK="/usr/lib/go/pkg/linux*/*.a /usr/lib/go/pkg/freebsd*/*.a /usr/lib/go/pkg/darwin*/*.a"
+
+if [[ ${PV} != 9999 ]]; then
+ S="${WORKDIR}"/go
+fi
+
+src_prepare()
+{
+ if [[ ${PV} != 9999 ]]; then
+ sed -i -e 's#"-Werror",##g' src/cmd/dist/build.c ||
+ die "sed failed"
+ fi
+ epatch_user
+}
+
+src_compile()
+{
+ export GOROOT_FINAL="${EPREFIX}"/usr/lib/go
+ export GOROOT="$(pwd)"
+ export GOBIN="${GOROOT}/bin"
+ if [[ $CTARGET = armv5* ]]
+ then
+ export GOARM=5
+ fi
+ tc-export CC
+
+ cd src
+ ./make.bash || die "build failed"
+}
+
+src_test()
+{
+ cd src
+ PATH="${GOBIN}:${PATH}" \
+ ./run.bash --no-rebuild --banner || die "tests failed"
+}
+
+src_install()
+{
+ dobin bin/*
+ dodoc AUTHORS CONTRIBUTORS PATENTS README
+
+ dodir /usr/lib/go
+ insinto /usr/lib/go
+
+ # There is a known issue which requires the source tree to be installed [1].
+ # Once this is fixed, we can consider using the doc use flag to control
+ # installing the doc and src directories.
+ # [1] https://golang.org/issue/2775
+ doins -r doc include lib pkg src
+ fperms -R +x /usr/lib/go/pkg/tool
+}
+
+pkg_preinst()
+{
+ has_version '<dev-lang/go-1.4' &&
+ export had_support_files=true ||
+ export had_support_files=false
+}
+
+pkg_postinst()
+{
+ # If the go tool sees a package file timestamped older than a dependancy it
+ # will rebuild that file. So, in order to stop go from rebuilding lots of
+ # packages for every build we need to fix the timestamps. The compiler and
+ # linker are also checked - so we need to fix them too.
+ ebegin "fixing timestamps to avoid unnecessary rebuilds"
+ tref="usr/lib/go/pkg/*/runtime.a"
+ find "${EROOT}"usr/lib/go -type f \
+ -exec touch -r "${EROOT}"${tref} {} \;
+ eend $?
+
+ if [[ ${PV} != 9999 && -n ${REPLACING_VERSIONS} &&
+ ${REPLACING_VERSIONS} != ${PV} ]]; then
+ elog "Release notes are located at http://golang.org/doc/go1.4"
+ fi
+
+ if $had_support_files; then
+ ewarn
+ ewarn "All editor support, IDE support, shell completion"
+ ewarn "support, etc has been removed from the go package"
+ ewarn "upstream."
+ ewarn "For more information on which support is available, see"
+ ewarn "the following URL:"
+ ewarn "https://github.com/golang/go/wiki/IDEsAndTextEditorPlugins"
+ fi
+}
diff --git a/dev-lang/go/metadata.xml b/dev-lang/go/metadata.xml
new file mode 100644
index 00000000..b8d86563
--- /dev/null
+++ b/dev-lang/go/metadata.xml
@@ -0,0 +1,13 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<!DOCTYPE pkgmetadata SYSTEM "http://www.gentoo.org/dtd/metadata.dtd">
+<pkgmetadata>
+ <maintainer>
+ <email>williamh@gentoo.org</email>
+ <name>William Hubbs</name>
+ </maintainer>
+ <longdescription lang="en">
+ Go is a new systems programming language developped at google by
+ Rob Pike. It has garbage collection, coroutines, communication
+ channels and a clean syntax.
+ </longdescription>
+</pkgmetadata>